// Code generated by protoc-gen-defaults. DO NOT EDIT.

package authorpb

import "context"

import "go.uber.org/fx"

import "github.com/golang/protobuf/ptypes/empty"

import "go.appointy.com/pehredaar/src/rights"

import "go.appointy.com/pehredaar/src/pehredaar"

import "go.appointy.com/pehredaar/src/user"

var AuthorsResourcePaths = [...]string{}

type RightsAuthorsServer struct {
	AuthorsServer
	rightsCli rights.RightValidatorsClient
	user      user.UserIDer
}

func init() {
	pehredaar.Options = append(pehredaar.Options, fx.Provide(NewRightsAuthorsClient))
}

type RightsAuthorsClientResult struct {
	fx.Out
	AuthorsClient AuthorsClient `name:"r"`
}

func NewRightsAuthorsClient(c rights.RightValidatorsClient, s AuthorsServer, u user.UserIDer) RightsAuthorsClientResult {
	return RightsAuthorsClientResult{AuthorsClient: NewLocalAuthorsClient(NewRightsAuthorsServer(c, s, u))}
}
func NewRightsAuthorsServer(c rights.RightValidatorsClient, s AuthorsServer, u user.UserIDer) AuthorsServer {
	return &RightsAuthorsServer{
		s,
		c,
		u,
	}
}

func (s *RightsAuthorsServer) CreateAuthor(ctx context.Context, rightsvar *CreateAuthorRequest) (*Author, error) {

	return s.AuthorsServer.CreateAuthor(ctx, rightsvar)
}

func (s *RightsAuthorsServer) GetAuthor(ctx context.Context, rightsvar *GetAuthorRequest) (*Author, error) {

	return s.AuthorsServer.GetAuthor(ctx, rightsvar)
}

func (s *RightsAuthorsServer) UpdateAuthor(ctx context.Context, rightsvar *UpdateAuthorRequest) (*empty.Empty, error) {

	return s.AuthorsServer.UpdateAuthor(ctx, rightsvar)
}

func (s *RightsAuthorsServer) DeleteAuthor(ctx context.Context, rightsvar *DeleteAuthorRequest) (*empty.Empty, error) {

	return s.AuthorsServer.DeleteAuthor(ctx, rightsvar)
}

func (s *RightsAuthorsServer) ListAuthor(ctx context.Context, rightsvar *ListAuthorsRequest) (*ListAuthorsResponse, error) {

	return s.AuthorsServer.ListAuthor(ctx, rightsvar)
}
